<template>
  <div class="inv">
    <div class="float-container">
      <div class="float-child-1">
        <!-- Inventory table starts here. -->
        <table class="table table-dark">
          <thead>
            <tr>
              <!-- These are the column titles. -->
              <th scope="col">ID</th>
              <th scope="col">Item</th>
              <th scope="col">Description</th>
              <th scope="col">Category</th>
              <th scope="col">{{inventory.customColumnOne}}</th>
              <th scope="col">{{inventory.customColumnTwo}}</th>
              <th scope="col">Stock</th>
            </tr>
          </thead>
          <tbody>
          <!-- V-for cycling through the items defined in the script. -->
            <tr v-for="item in filteredItems" :key="item">
              <th scope="row">{{ item.slug }}</th>
              <td id="lColumn">{{ item.itemName }}</td>
              <td id="lColumn">{{ item.body }}</td>
              <td>{{ item.category }}</td>
              <td>{{ item.customColumnOneData }}</td>
              <td>{{ item.customColumnTwoData }}</td>
              <!-- v-if here. No stock results in no number displayed. -->
              <td v-if="item.stockLevel != null">{{ item.stockLevel }}</td>
              <!-- This is the start of the button code area. -->
              <td style="white-space: nowrap;">
                <!-- Substract button. At click, the stockLevel is reduced by one. -->
                <button type="button" class="btn btn-warning" style="margin: 5px;" @click="removeStock(item)">
                  <!-- This is the code for the minus icon. -->
                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-patch-minus-fill" viewBox="0 0 16 16">
                    <path d="M10.067.87a2.89 2.89 0 0 0-4.134 0l-.622.638-.89-.011a2.89 2.89 0 0 0-2.924 2.924l.01.89-.636.622a2.89 2.89 0 0 0 0 4.134l.637.622-.011.89a2.89 2.89 0 0 0 2.924 2.924l.89-.01.622.636a2.89 2.89 0 0 0 4.134 0l.622-.637.89.011a2.89 2.89 0 0 0 2.924-2.924l-.01-.89.636-.622a2.89 2.89 0 0 0 0-4.134l-.637-.622.011-.89a2.89 2.89 0 0 0-2.924-2.924l-.89.01-.622-.636zM6 7.5h4a.5.5 0 0 1 0 1H6a.5.5 0 0 1 0-1z"/>
                  </svg>
                  <!-- End of the code for the minus icon. -->
                </button>
                <!-- Cog button. At click, a modal is opened to allow the user to modify an item. -->
                <button type="button" class="btn btn-secondary" style="margin: 5px;" @click="handleEdit(item, inventory)">
                  <!-- This is the code for the cog icon. -->
                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-gear-fill" viewBox="0 0 16 16">
                    <path d="M9.405 1.05c-.413-1.4-2.397-1.4-2.81 0l-.1.34a1.464 1.464 0 0 1-2.105.872l-.31-.17c-1.283-.698-2.686.705-1.987 1.987l.169.311c.446.82.023 1.841-.872 2.105l-.34.1c-1.4.413-1.4 2.397 0 2.81l.34.1a1.464 1.464 0 0 1 .872 2.105l-.17.31c-.698 1.283.705 2.686 1.987 1.987l.311-.169a1.464 1.464 0 0 1 2.105.872l.1.34c.413 1.4 2.397 1.4 2.81 0l.1-.34a1.464 1.464 0 0 1 2.105-.872l.31.17c1.283.698 2.686-.705 1.987-1.987l-.169-.311a1.464 1.464 0 0 1 .872-2.105l.34-.1c1.4-.413 1.4-2.397 0-2.81l-.34-.1a1.464 1.464 0 0 1-.872-2.105l.17-.31c.698-1.283-.705-2.686-1.987-1.987l-.311.169a1.464 1.464 0 0 1-2.105-.872l-.1-.34zM8 10.93a2.929 2.929 0 1 1 0-5.86 2.929 2.929 0 0 1 0 5.858z"/>
                  </svg>
                  <!-- End of the code for the cog icon. -->
                </button>
                <!-- Trash button. At click, a call is sent to the view to delete the item. -->
                <button type="button" class="btn btn-danger" style="margin: 5px;" @click="handleDelete(item.item_id)">
                  <!-- This is the code for the trash icon. -->
                  <svg xmlns="http://www.w3.org/2000/svg" width="16" height="16" fill="currentColor" class="bi bi-trash-fill" viewBox="0 0 16 16">
                    <path d="M2.5 1a1 1 0 0 0-1 1v1a1 1 0 0 0 1 1H3v9a2 2 0 0 0 2 2h6a2 2 0 0 0 2-2V4h.5a1 1 0 0 0 1-1V2a1 1 0 0 0-1-1H10a1 1 0 0 0-1-1H7a1 1 0 0 0-1 1H2.5zm3 4a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 .5-.5zM8 5a.5.5 0 0 1 .5.5v7a.5.5 0 0 1-1 0v-7A.5.5 0 0 1 8 5zm3 .5v7a.5.5 0 0 1-1 0v-7a.5.5 0 0 1 1 0z"/>
                  </svg>
                  <!-- End of the code for the trash icon. -->
                </button>
              </td>
              <!-- End of the area designated to code the buttons. -->
            </tr>
          </tbody>
        </table>
      </div>
      <!-- Here starts the html for the filters area. -->
      <div class="float-child-2">
        <div class="col-lg-3 mb-4">
          <tr><h4 style="margin-top: 15px; white-space: nowrap;">Filter your items</h4></tr>
          <h6 class="mt-1" style="white-space: nowrap;">By category: </h6>
          <div class="form-check">
            <input class="form-check-input" type="radio" :value="''" v-model="selected" :id="category" :checked="stockSelected != null">
            <label class="form-check-label" :for="category"> All </label>
          </div>
          <!-- Here all unique categories are cycled through and turned into options for the filter. -->
          <div class="form-check" v-for="category in categories" :key="category">
            <input class="form-check-input" type="radio" :value="category" v-model="selected" :id="category" :unchecked="stockSelected != null">
            <label class="form-check-label" :for="category"> {{ category }} </label>
          </div>
          <br>
          <h6 class="mt-1" style="white-space: nowrap;">By stock level: </h6>
          <div class="form-check">
            <input class="form-check-input" type="radio" :value="null" v-model="stockSelected" :id="stockLevel">
            <label class="form-check-label" :for="stockLevel"> Any </label>
          </div>
          <!-- Here a premade set of values is cycled through and displayed. -->
          <div class="form-check" v-for="stockLevel in levels" :key="stockLevel">
            <input class="form-check-input" type="radio" :value="stockLevel" v-model="stockSelected" :id="stockLevel">
            <label class="form-check-label" :for="stockLevel"> &lt;&nbsp;{{ stockLevel }} </label>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from 'axios'
export default {
  // name of the component
  name: 'inv',
  props: {
    inventory: Object,
    sortValue: Boolean,
    sortType: Boolean
  },
  // data() holds values that are initialized when the page loads
  data () {
    return {
      baseUrl: 'http://localhost:8000/api/',
      item: {},
      items: [],
      category: '',
      categories: [],
      selected: '',
      stockSelected: null,
      stockLevel: Number,
      levels: [5, 10, 25, 50, 100, 250]
    }
  },
  computed: {
    // filter method to return the appropriate items to be displayed in the table after every change
    // in the web page.
    filteredItems: function () {
      return this.items.filter((item) => {
        if (this.stockSelected == null) {
          return item.category.match(this.selected)
        } else {
          return item.stockLevel < this.stockSelected
        }
      }).sort((a, b) => {
        let fa = ''
        let fb = ''
        if (this.sortValue === true) {
          fa = a.slug.toLowerCase()
          fb = b.slug.toLowerCase()
        } else if (this.sortValue === false) {
          fa = a.itemName.toLowerCase()
          fb = b.itemName.toLowerCase()
        } else if (this.sortValue === null) {
          fa = a.created_at.toLowerCase()
          fb = b.created_at.toLowerCase()
        }
        if (this.sortType === true) {
          if (fa < fb) {
            return -1
          }
          if (fa > fb) {
            return 1
          }
        } else if (this.sortType === false) {
          if (fa < fb) {
            return 1
          }
          if (fa > fb) {
            return -1
          }
        } else {
          return 0
        }
        return 0
      })
    }
  },
  // methods is the class where methods are defined to be used later
  methods: {
    // This code is very simple. It takes the item where the reduce button was pressed and updates it
    // in the database with the stock level reduced by 1 unit.
    removeStock (item) {
      if (item.stockLevel > 0) {
        item.stockLevel--
        axios.put(this.baseUrl + 'items', {
          item_id: item.item_id,
          inventory_id: item.inventory_id,
          slug: item.slug,
          itemName: item.itemName,
          body: item.body,
          stockLevel: item.stockLevel,
          category: item.category,
          customColumnOneData: item.customColumnOneData,
          customColumnTwoData: item.customColumnTwoData
        })
      }
    },
    // some emit methods firing up methods in parent classes
    handleDelete (id) {
      this.$emit('delete-item', id)
    },
    handleEdit (item, inventory) {
      this.$emit('selected-item', item, inventory)
      this.$router.push('/inventory/' + inventory.inventory_id + '/edit')
    },
    // This method receives an array of objects (items) and creates and array of unique values
    // based on the 'category' column on the object array.
    getCategories (it) {
      const allCategories = it.map(item => item.category)
      this.categories = [...new Set(allCategories)]
    }
  },
  // mounted is similar to the main method in java: it runs automatically on page load
  mounted () {
    axios.get(this.baseUrl + 'items', {
      params: {
        inventory_id: this.inventory.inventory_id
      }
    }).then(response => {
      this.items = response.data
      this.getCategories(this.items)
    })
  }
}
</script>

<style scoped='scss'>
/* css for the inventory table */
#table {
    width: 65%;
    margin: 20px;
    margin-top: 20px;
}
#lColumn {
    text-align: left;
}
.float-container {
  padding: 20px;
}
.float-child-1 {
  width: 75%;
  float: left;
  padding-right: 1%;
}
.float-child-2 {
  width: 20%;
  height: auto;
  float: right;
  padding-left: 1%;
  background: rgba(10, 10, 20, 0.753);
  color: white;
}
</style>
